program despace(input, output);
(* despace: remove space character duplications

  Thomas D. Schneider, Ph.D.
  toms@alum.mit.edu
  toms@alum.mit.edu (permanent)
  https://alum.mit.edu/www/toms (permanent)

 *)

label 1; (* end of program *)

const
(* begin module version *)
   version = 1.03; (* of despace.p 2015 Mar 26
2015 Mar 26, 1.03: loss of first space for second and later lines?
2015 Mar 26, 1.02: started from dedup
2015 Mar 26, 1.01: handle first character properly
2015 Mar 26, 1.00: origin
*)
updateversion = 1.00; (* defines lowest acceptable current parameter file *)
(* end module version *)

(* begin module describe.despace *)
(*
name
   despace: remove space character duplications

synopsis
   despace(input: in, output: out)

files

   input:  input file

   output: input file with duplicated space characters removed.

description

   The input file is copied to the output file and when a character
   matches the previous character it is not output.

examples

   The string:
     'hi    therrre'
   becomes:
     'hi therrre'

documentation

see also

   rembla, rb, dedup

author

   Thomas Dana Schneider

bugs

technical notes

*)
(* end module describe.despace *)

(* begin module halt *)
procedure halt;
(* stop the program.  the procedure performs a goto to the end of the
   program.  you must have a label:
      label 1;
   declared, and also the end of the program must have this label:
      1: end.
   examples are in the module libraries.
   this is the only goto in the delila system. *)
begin
      writeln(output,' program halt.');
      goto 1
end;
(* end module halt version = 'delmod 6.16 84 mar 12 tds/gds'; *)

(* begin module despace.themain *)
procedure themain(var fin, fout: text);
(* the main procedure of the program *)
var
   parameterversion: real; (* parameter version number *)
   previous: char; (* a previous character *)
begin
(*
   writeln(output,'despace ',version:4:2);
*)

   previous := '-';
   while not eof(fin) do begin
      (* copy a line *)
      while (not eoln(fin)) and (not eof(fin)) do begin
         if not ((previous = ' ') and (fin^ = ' '))
         then begin
            write(fout, fin^);
         end;
         previous := fin^;
         get(fin)
      end;
      writeln(fout);
      readln(fin);
      previous := '-'; (* reset for each line *)
   end;

end;
(* end module despace.themain *)

begin
   themain(input, output);
1: end.
