program whole(input, output);
(* whole: create whole lines

  Tom Schneider
  toms@alum.mit.edu
  https://alum.mit.edu/www/toms/


 *)

label 1; (* end of program *)

const
(* begin module version *)
version = 1.01; (* of whole.p 1997 November 3
origin 1997 Nov 3 *)
updateversion = 1.00; (* defines lowest acceptable current parameter file *)
(* end module version *)

(* begin module describe.whole *)
(*
name
   whole: create whole lines

synopsis
   whole(input: in, output: out)

files
   input:  a file

   output: the file without an incomplete final line if it existed.

description

   The program reads lines from input and puts complete ones that
   end with an end of line to the output.
   Lines at the end of the file are ignored.
   This allows one to strip incomplete lines from a data file
   to allow plotting by xyplo, while the data file is being made.

   THE PROGRAM SIMPLY REMOVES THE LAST LINE NO MATTER WHAT.

examples

documentation

see also
   xyplo

author
   Thomas Dana Schneider

bugs

technical notes
   linemax is a constant that is the maximum length of lines

*)
(* end module describe.whole *)

(* begin module whole.themain *)
procedure themain;
(* the main procedure of the program *)
const
   linemax = 300; (* longest line that can be handled by the program *)
var
   i: integer; (* index to line array *)
   l: array[1..linemax] of char;
   length: integer; (* current length of stored line *)
begin
   length := 0;
   while not eof(input) do begin
      if eoln(input) then begin
         readln(input);
{
         if eof(input) then writeln(output,'EOF!');
}
         if not eof(input) then begin
            for i := 1 to length do write(output,l[i]);
            writeln(output);
         end;
         length := 0;
      end
      else begin
         length := length + 1;
         read(input,l[length]);
      end
   end;
end;
(* end module whole.themain *)

begin
   themain;
1: end.
