program woco(input, output);
(* woco: word counting program

  Thomas D. Schneider, Ph.D.
  toms@alum.mit.edu
  https://alum.mit.edu/www/toms 

*)

label 1; (* end of program *)

const
(* begin module version *)
  version = 1.09; (* of woco 2016 Jan 24
2016 Jan 24 1.09: debug:
  sed -i.bak "s|'9','0'|'9'|g"                      woco.p
1988 Jul 5, 1.08: functional
1987 Jul 5, 1.00: origin
origin 1987 July 5 *)
(* end module version *)

(* begin module describe.woco *)
(*
name
   woco: word counting program

synopsis
   woco(input: in, output: out)

files
   input:  a file to find the number of words in
   output: number of words in the file

description
   The program knows about latex constructs a little.
   A word is defined to be any contiguous string of A-Z, a-z, 0-9,
   excluding those that begin with a \.

author
   Thomas Dana Schneider

bugs
   none known

*)
(* end module describe.woco *)


(* begin module woco.themain *)
procedure themain(var afile: text);
(* the main procedure of the program *)
var
  c: char; (* a character from afile *)
  count: integer; (* count of the words *)
  inside: boolean; (* true if inside a word *)
begin
   writeln(output,'woco ',version:4:2);

  count := 0;
  inside := false;

  while not eof(afile) do begin
    while not eoln(afile) do begin
      read(afile,c); 
(*
write(output,'[',c,']');
*)
      if (c in [
'a','b','c','d','e','f','g','h','i','j','k','l','m','n','o','p','q','r','s',
't','u','v','w','x','y','z',
'A','B','C','D','E','F','G','H','I','J','K','L','M','N','O','P','Q','R','S',
'T','U','V','W','X','Y','Z',
'0','1','2','3','4','5','6','7','8','9'
               ]) then begin
         (* if this is the start of a word *)
         if not inside then count := count + 1;
(*
if not inside then write(output,count:1);
*)
         inside := true;
      end
      (* don't count control words - skip them *)
      else if c = '\' then inside := true
                      else inside := false (* stops words *)
    end;
    readln(afile);
    inside := false;
  end;
  writeln(output);
  writeln(output,count:1);
end;
(* end module woco.themain *)

begin
   themain(input);
1: end.
